# boilerplate for the various scripts that emulate gcc, ar, etc.
#
# ADOBE SYSTEMS INCORPORATED
# Copyright 2008 Adobe Systems Incorporated. All Rights Reserved.
#
# NOTICE:  Adobe permits you to use, modify, and distribute this file in
# accordance with the terms of the Adobe license agreement accompanying it.
# If you have received this file from a source other than Adobe, then your use,
# modification, or distribution of it requires the prior written permission of Adobe.
#


$0 =~ /^(.*)\/([^\/]+)$/;
$path = $1;
$name = $name || $2;
# remove ourself from the path
$ENV{PATH} =~ s/(?:^|\:)$path\/*(?:\:+|$)//g;

# 'fix' a pathname
sub pfix
{
  my $p = (shift);
  # make /usr/ to local to us
  $p =~ s/(^|^-[-\w]+=?)(\/usr\/include\/)/$1${home}\/avm2-libc\/include\//;
  $p =~ s/(^|^-[-\w]+=?)(\/usr\/)/$1${home}$2/;
  # make pathes mixed on cygwin
  if(`uname` =~ /CYGWIN/)
  {
    my $pp;

    $p =~ s/(^|^-[-\w]+=?)(\/.*)/chomp($pp = `cygpath -a -m '$2'`), $1.$pp/e;
  }
  return $p;
}

# 'fix' pathes and have the system execute a command
sub sys
{
  my @nargs = map { pfix($_) } @_;
  if($log)
    { print LOG join(" ", @nargs) . "\n" }
  system(@nargs);
  if($?)
    { exit($?) }
}

# grab the home of the Alchemy environment
$home=$ENV{ALCHEMY_HOME} || $ENV{HOME};
$ascjar=$ENV{ASC} || "$home/asm-asc/lib/asc.jar";
$log=$ENV{LOG};

if($log)
{
  open(LOG, ">>/tmp/${name}.log");
  print LOG "---:" . join(" ", @ARGV) . "\n";
}

1;
