#!/usr/bin/perl
#
# junky script to "inflate" a SWF -- tags are turned into files
# in the current directory
#
# ADOBE SYSTEMS INCORPORATED
# Copyright 2008 Adobe Systems Incorporated. All Rights Reserved.
#
# NOTICE:  Adobe permits you to use, modify, and distribute this file in
# accordance with the terms of the Adobe license agreement accompanying it.
# If you have received this file from a source other than Adobe, then your use,
# modification, or distribution of it requires the prior written permission of Adobe.
#

open(SWF, $ARGV[0]);
binmode(SWF);

read(SWF, $head, 8);

if(substr($head, 0, 1) eq 'C')
{
  substr($head, 0, 1) = 'F';
  $temp = "$$.achacks.S";
  $use_zpipe = qx/which zpipe/;
  if($use_zpipe) {
    sys("zpipe", "<$SWF", ">$temp");
  }
  else {
    sys("zpipe.pl", "<$SWF", ">$temp");
  }
  close(SWF);
  open(SWF, "<$temp");
  binmode(SWF);
}

open(OUT, ">000000.head");
binmode(OUT);

print OUT $head;

read(SWF, $rect1, 1);
print OUT $rect1;
$rbits = unpack("C", $rect1) >> 3;
$rrbytes = int((7 + ($rbits * 4) - 3) / 8);
read(SWF, $rectr, $rrbytes);
print OUT $rectr;
read(SWF, $frameRate, 2);
print OUT $frameRate;
print "frame rate: " . unpack("v", $frameRate) / 256.0 . "\n";
read(SWF, $frameCount, 2);
print OUT $frameCount;
print "frame count: " . unpack("v", $frameCount) . "\n";

close(OUT);

$blockno = 1;

do
{
  read(SWF, $code, 2);
  $code = unpack("v", $code);
  $tag = $code >> 6;
  $len = ($code & 0x3f);
  $bhead = 2;
  if($len == 0x3f)
  {
    read(SWF, $len, 4);
    $len = unpack("V", $len);
    $bhead += 4;
  }
  print "$tag : $len\n";
  if($tag == 82) # DoABC2
  {
    read(SWF, $data, $len);
    $n = 4;
    while(substr($data, $n, 1) ne "\0")
      { $n++ }
    $rsvd = unpack("V", substr($data, 0, 4));
    $name = substr($data, 4, $n - 4);
    $name =~ s/([^A-Za-z0-9])/sprintf("_%02x", ord($1))/eg;
    $n++; # null term
    open(OUT, sprintf(">%04d00_%08x_%s.%03x", $blockno++, $rsvd, $name, $tag));
    binmode(OUT);
    print OUT substr($data, $n);
    close(OUT);
  }
  elsif($tag == 87) # Binary data
  {
    read(SWF, $data, $len);
    $id = unpack("v", substr($data, 0, 2));
    $rsvd = unpack("V", substr($data, 2, 4));
    open(OUT, sprintf(">%04d00_%04x_%08x.%03x", $blockno++, $id, $rsvd, $tag));
    binmode(OUT);
    print OUT substr($data, 6);
    close(OUT);
  }
  else
  {
    open(OUT, sprintf(">%04d00.%03x", $blockno++, $tag));
    binmode(OUT);
    read(SWF, $data, $len);
    print OUT $data;
    close(OUT);
  }
} while($tag != 0);
do
{
  read(SWF, $rest, 1);
} while(length($rest));
if($temp)
  { system("rm", $temp) }
